#include <oswrapper.h>
#if AJB_USE_CLI_CONFIGURATIONS
extern  Word16   AJB_ISR_SCHEDULER_DURATION[MAX_VOICE_CHANNELS];
AJBCliParaSt_    AJBCon[MAX_VOICE_CHANNELS];
extern uWord16   AJB_AllowNullPlayPassFailCnt[MAX_VOICE_CHANNELS];
extern uWord16   AJB_AllowNullPlayPassFailCntThr[MAX_VOICE_CHANNELS];
extern uWord16   AJB_READ_THRESHOLD[MAX_VOICE_CHANNELS];
extern uWord16   AJB_AllowNullPlayPassFailCnt[MAX_VOICE_CHANNELS];
extern uWord16   AJB_AllowNullPlayPassFailCntThr[MAX_VOICE_CHANNELS];
extern uWord16   AJB_MIN_DELAY_MS[MAX_VOICE_CHANNELS];
extern uWord16   AJB_MAX_DELAY_MS[MAX_VOICE_CHANNELS];
extern JitBuffType_  SMMJitBuff[MAX_VOICE_CHANNELS];
extern uWord16   AJB_DEL_OFFSET_MS[MAX_VOICE_CHANNELS];
extern uWord16   AJB_ALLOW_PKT_DROP_PER_SLOT[MAX_VOICE_CHANNELS];
extern uWord16   AJB_ALLOW_NULLS_PER_SLOT[AJB_MAX_NO_OF_DELAY_LEVELS];
extern uWord16   AJB_TOTAL_PKTS_PER_SLOT[MAX_VOICE_CHANNELS];
extern uWord16   AJB_DELAY_EST_TIMER[MAX_VOICE_CHANNELS];
extern uWord16   AJB_DELAY_DROP_TIMER[MAX_VOICE_CHANNELS];
extern uWord16   AJB_DELAY_EST_SIGMA_FACTOR[MAX_VOICE_CHANNELS];
extern uWord16   AJB_GAP_DELAY_EST_SIGMA_FACTOR[MAX_VOICE_CHANNELS];
extern uWord16   AJB_DELAY_TRACK_SIGMA_FACTOR[MAX_VOICE_CHANNELS];
extern uWord32   AJB_WRITE_CNTR[MAX_VOICE_CHANNELS];
extern uWord32   AJB_READ_CNTR[MAX_VOICE_CHANNELS];
extern Markov4StateType_  Markov4Data[MAX_VOICE_CHANNELS];
uWord16  AJBDebug[MAX_VOICE_CHANNELS][AJB_DEBUG_LOGGER_LEN];

char AJBDebugStr[AJB_DEBUG_LOGGER_LEN][20] =
{
{"WtErrFlag"},  {"RdErrFlag"},   {"ReadThr"},    {"GapOff"},
{"FreeRtpCnt"}, {"FreeCellCnt"}, {"ListRtpCnt"}, {"ListCellCnt"},
{"WtOFDropCnt"},{"WtDupDropCnt"}, {"WtNoCMDropCnt"}, {"WtNoRMDropCnt"},
{"Sai"},        {"Sai"},          {"DelTraTot"},  {"PlayOutDelay"},
{"CodecType"}, {"FrameLen" },      {"ExpRdSqNum"}, {"LastRdSqNum"}
};

#if AJB_ENABLE_STATISTICS
extern uWord32  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIMER[MAX_VOICE_CHANNELS];
extern uWord32  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME[MAX_VOICE_CHANNELS];
extern uWord16  AJB_STASTICS_RESET_TIMER[MAX_VOICE_CHANNELS];
extern uWord16  AJB_RESET_ON_MAX_LATE_PKT_DROP_TIMER[MAX_VOICE_CHANNELS];;
extern uWord16  AJB_HISTORY_INDEX[MAX_VOICE_CHANNELS];
extern uWord16  AJB_TOT_PKT_CNT_WT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_DUP_PKT_CNT_WT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_OVF_PKT_CNT_WT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_LIST_MAX[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_LIST_MIN[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_LIST_NUL[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_ALLOW_NULL[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_LIST_CUR[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_DELAY_EST_MAX[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_DELAY_EST_MIN[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_DELAY_EST_CUR[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];

extern uWord16  AJB_LATE_ARRIVE_DROP_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_DELAY_TRACK_DROP_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];

extern uWord16  AJB_DELAY_TRACK_DROP_FREQ_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_LATE_ARRIVA_DROP_FREQ_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_NULLPKT_PLAY_OUT_FREQ_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];

extern uWord16  AJB_READ_ERROR_FLAG_HIST[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_WRIT_ERROR_FLAG_HIST[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16  AJB_AllowNullPlayPassFailCntHist[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord32  AJB_HIST_TOT_PKT_CNT_WT[MAX_VOICE_CHANNELS];
#endif

void AJBDebugTraceCLI(uWord16 PortNum)
{
   //---> Group -4 words.
   AJBDebug[PortNum][0]   =  SMMJitBuff[PortNum].WtErrFlag;
   AJBDebug[PortNum][1]   =  SMMJitBuff[PortNum].RdErrFlag;
   AJBDebug[PortNum][2]   =  AJB_READ_THRESHOLD[PortNum];
   AJBDebug[PortNum][3]   =  SMMJitBuff[PortNum].GapOffset;

   AJBDebug[PortNum][4]   =  SMMJitBuff[PortNum].FreeRtpCnt;
   AJBDebug[PortNum][5]   =  SMMJitBuff[PortNum].FreeCellCnt;
   AJBDebug[PortNum][6]   =  SMMJitBuff[PortNum].ListRtpCnt;
   AJBDebug[PortNum][7]   =  SMMJitBuff[PortNum].ListCellCnt;

   AJBDebug[PortNum][8]   =  SMMJitBuff[PortNum].WtOFDropCnt;
   AJBDebug[PortNum][9]   =  SMMJitBuff[PortNum].WtDupDropCnt;
   AJBDebug[PortNum][10]  =  SMMJitBuff[PortNum].WtNoCellMemDropCnt;
   AJBDebug[PortNum][11]  =  SMMJitBuff[PortNum].WtNoRtpMemDropCnt;


 //AJBDebug[13]  =  SMMJitBuff[AJBDebugPortNum].DelayTrackPktDropTotal;
   AJBDebug[PortNum][15]  =  SMMJitBuff[PortNum].PlayOutDelay;


   AJBDebug[PortNum][16]  =  SMMJitBuff[PortNum].CodecType;
   AJBDebug[PortNum][17]  =  SMMJitBuff[PortNum].FrameLen;
   AJBDebug[PortNum][18]  =  SMMJitBuff[PortNum].ExpReadSeqNum;
   AJBDebug[PortNum][19]  =  SMMJitBuff[PortNum].LastReadSeqNum;
}



/*************************************************************************
  Function to set AJB with Default Configurations                       
*************************************************************************/
void AJBDefCon(uWord16 PortNum )
{
  if( confGetJBType() == FJB)
  {
    AJBCon[PortNum].CLI_AJB_Mode          = FJB;
  }
  else
    AJBCon[PortNum].CLI_AJB_Mode          = AJB;
  AJBCon[PortNum].CLI_AJB_MIN_DELAY_MS  = 0;
  AJBCon[PortNum].CLI_AJB_MAX_DELAY_MS  = DEF_AJB_MAX_DELAY_MS;
  AJBCon[PortNum].CLI_AJB_DEL_OFFSET_MS = DEF_AJB_DEL_OFFSET_MS;

  AJBCon[PortNum].CLI_AJB_DELAY_EST_TIMER   = DEF_AJB_DELAY_EST_TIMER;
  AJBCon[PortNum].CLI_AJB_DELAY_DROP_TIMER  = DEF_AJB_DELAY_DROP_TIMER;
  AJBCon[PortNum].CLI_AJB_ALLOW_PKT_DROP_PER_SLOT = 
                                       DEF_AJB_ALLOW_PKT_DROP_PER_SLOT;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[0] =   
                              DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL1_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[1]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL2_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[2]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL3_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[3]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL4_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[4]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL5_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[5]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL6_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[6]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL7_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[7]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL8_DELAY;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[8]
				=   DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL9_DELAY;
     
  AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME
                        =   DEF_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME;
  AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME 
                        =  DEF_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME;
  AJBCon[PortNum].CLI_AJB_AllowNullPlayPassFailCntThr
                        =  DEF_AJB_ALLOW_NULL_PLAY_PASS_FAIL_CNT_THR;

  AJBCon[PortNum].CLI_AJB_DELAY_EST_SIGMA_FACTOR    =
                           DEF_AJB_DELAY_EST_SIGMA_FACTOR;
  AJBCon[PortNum].CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR = 
                           DEF_AJB_GAP_DELAY_EST_SIGMA_FACTOR;
  AJBCon[PortNum].CLI_AJB_DELAY_TRACK_SIGMA_FACTOR    =
                           DEF_AJB_DELAY_TRACK_SIGMA_FACTOR;
  AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER = 
                           DEF_AJB_STASTICS_RESET_TIMER;
}

void AJBLoadCLIConf(uWord16 PortNum)
{
  int i;
  AJB_AllowNullPlayPassFailCntThr[PortNum]  =
                 AJBCon[PortNum].CLI_AJB_AllowNullPlayPassFailCntThr;

  AJB_MIN_DELAY_MS[PortNum]  =  AJBCon[PortNum].CLI_AJB_MIN_DELAY_MS;
  AJB_MAX_DELAY_MS[PortNum]  =  AJBCon[PortNum].CLI_AJB_MAX_DELAY_MS;
  AJB_DEL_OFFSET_MS[PortNum] =  AJBCon[PortNum].CLI_AJB_DEL_OFFSET_MS;
  for( i = 0; i < AJB_MAX_NO_OF_DELAY_LEVELS; i++ )
    AJB_ALLOW_NULLS_PER_SLOT[i] =  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[i];

  AJB_TOTAL_PKTS_PER_SLOT[PortNum] = 
        ( AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER/SMMJitBuff[PortNum].DelRemStepMS);
  //---> Delay Drop Timer---------
  AJB_DELAY_DROP_TIMER[PortNum] = 
   (AJBCon[PortNum].CLI_AJB_DELAY_DROP_TIMER  / AJB_ISR_SCHEDULER_DURATION[PortNum]);
  //------------Allowed Max No of   Packet drops per one entry-----------
  AJB_ALLOW_PKT_DROP_PER_SLOT[PortNum] =
    AJBCon[PortNum].CLI_AJB_ALLOW_PKT_DROP_PER_SLOT;
  //-------------------DELAY ESTIMATION MODULE TIMERS--------------------
  AJB_DELAY_EST_TIMER[PortNum] =
     AJBCon[PortNum].CLI_AJB_DELAY_EST_TIMER/ AJB_ISR_SCHEDULER_DURATION[PortNum];
  //-------------------AJB STATSTICS RESET TIMETR CONTROLS---------------
#if AJB_ENABLE_STATISTICS
  AJB_STASTICS_RESET_TIMER[PortNum] =
   AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER/ AJB_ISR_SCHEDULER_DURATION[PortNum];
  //---------------------AJB NULL &DROPS HITS RESET TIMTERS--------------
  AJB_RESET_ON_MAX_LATE_PKT_DROP_TIMER[PortNum] =
    AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME/ SMMJitBuff[PortNum].RxFrameMS;
  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIMER[PortNum] =
    AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME/ SMMJitBuff[PortNum].DelRemStepMS;
#endif

  //---------------------SIGMA FACTORS-----------------------------------
  //---> Delay Estimation -SigmaFactor
  AJB_DELAY_EST_SIGMA_FACTOR[PortNum] = AJBCon[PortNum].CLI_AJB_DELAY_EST_SIGMA_FACTOR;
  //---> Gap Estimation ->SigmaFactor
  AJB_GAP_DELAY_EST_SIGMA_FACTOR[PortNum] =
     AJBCon[PortNum].CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR;
  //---> Delay TrackDowm -SigmaFactor
  AJB_DELAY_TRACK_SIGMA_FACTOR[PortNum] =
    AJBCon[PortNum].CLI_AJB_DELAY_TRACK_SIGMA_FACTOR;

}




void Cli_AJBWtPara( uWord16 PortNum, uWord16 Index, uWord16 Value )
{

  switch(Index)
  {
    case 0 :
      if((Value >= 10 )&&( Value <  400 ))
        AJBCon[PortNum].CLI_AJB_MIN_DELAY_MS = Value;
      else
        printk("\r\nMinDelayMax:400ms/Min:10ms");
      break;
    case 1 :
      if((Value >= 30 )&&( Value <= DEF_AJB_MAX_DELAY_MS ))
        AJBCon[PortNum].CLI_AJB_MAX_DELAY_MS = Value;
      else
        printk("\r\nMiaxDelayMax:500ms/Min:30ms");
      break;
    case 2 :
      if((Value >= 1 )&&( Value <= 180 ))
        AJBCon[PortNum].CLI_AJB_DEL_OFFSET_MS = Value;
      else
        printk("\r\nSampCntr Max:180/Min:1");
      break;
    case 3 :
      if((Value >= 10 )&&( Value <= 10000 ))
        AJBCon[PortNum].CLI_AJB_DELAY_EST_TIMER = Value;
      else
        printk("\r\nSampCntr Max:10000ms/Min:10ms");
      break;
    case 4 :
      if((Value >= 10 )&&( Value <= 60000 ))
	AJBCon[PortNum].CLI_AJB_DELAY_DROP_TIMER = Value;
      else
        printk("\r\nSampCntr Max:60,000ms/Min:10ms");
      break;
    case 5 :
      if((Value >= 1 )&&( Value <= 100 ))
        AJBCon[PortNum].CLI_AJB_ALLOW_PKT_DROP_PER_SLOT = (Value-1);
      else
        printk("\r\nMaxPktdrop per entry Max:100/Min:1");
      break;
    case 6 :
      if((Value >= 1 )&&( Value <= 600 ))
	AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME = Value*1000;
      else
        printk("\r\nRstOnNull Max:600Sec/Min:1Sec");
      break;
    case 7 :
      if((Value >= 100 )&&( Value <= 60000 ))
        AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME = Value;
      else
        printk("\r\nRstSEqNumOnLateDrop Max:60,000ms/Min:100ms");
      break;
    case 8 :
      if( Value <= AJB_HISTORY_LEN )
        AJBCon[PortNum].CLI_AJB_AllowNullPlayPassFailCntThr = Value;
      else
        printk("\r\nHistNullThr Max:AJB_HISTORY_LEN/Min:0");
      break;
    case  9 :
    case 10 :
    case 11 :
    case 12 :
    case 13 :
    case 14 :
    case 15 :
    case 16 :
    case 17 :
      if( Value <= 100 )
        AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[Index-9] = Value;
      else
	printk("\r\nAllDropPercent Max:100/Min:0");
      break;
    case 18 :
      if((Value ==  AJB )||( Value == FJB ))
        AJBCon[PortNum].CLI_AJB_Mode = Value;
      else
        printk("\r\nErr in config AJBMode:AJB[%d]FJB[%d]", AJB,FJB);
      break;
    case 19 :
      if((Value >= 100 )&&( Value <= 60000 ))
        AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER = Value;	
      else
        printk("\r\nStastic-resetTimerMS-Max:60000ms/Min:100ms");
      break;
    case 20 :
      if( Value <= 200 )
        AJBCon[PortNum].CLI_AJB_DELAY_EST_SIGMA_FACTOR = Value;
      else
        printk("\r\nDelEstSigma-inPer Max:200/Min:0");
      break;
    case 21 :
      if( Value <= 200 )
        AJBCon[PortNum].CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR = Value;
      else
        printk("\r\nDelGapEstSigma-inPer Max:200/Min:0");
      break;
    case 22 :
      if( Value <= 200 )
        AJBCon[PortNum].CLI_AJB_DELAY_TRACK_SIGMA_FACTOR = Value;
      else
        printk("\r\nDelTrackSigma-inPer Max:200/Min:0");
      break;
    case 23 :
      if( Value == 32767 )
      {
        SMMJitBuff[PortNum].Reset = 1;
        switchJitterBuffToFjb(PortNum);
        printk("\r\nAJB-RESET");
      }
      else
	printk("\r\nAJB-resetTRY:0x7FFF");
      break;
    case 24 :
      if( Value == 32767 )
      {
        AJBDefCon(PortNum );
        printk("\r\nAJBDefault-ConfigDone");
      }
      else
        printk("\r\nAJBDefault-Config TRY:0x7FFF");
      break;
    default :
      printk("\r\nAJBConfigWtIndexErr[%d]",Index);
      break;
  }//--> End of Switch Statement.
}//--> End of Cli_AJBSetPara


void Cli_AJBReadPara( uWord16 PortNum, uWord16 Index, uWord16 SubIndex  )
{
#if AJB_ENABLE_STATISTICS
  uWord16 *TempPtr,HistInd;
#endif 
  int i;
  AJBDebugTraceCLI(PortNum);
  switch(Index)
  {
    case 0 :
      printk("\r\nAJBMinDelayMS[%d]",AJBCon[PortNum].CLI_AJB_MIN_DELAY_MS);
      break;
    case 1 :
      printk("\r\nAJBMaxDelayMS[%d]",AJBCon[PortNum].CLI_AJB_MAX_DELAY_MS);
      break;
    case 2 :
      printk("\r\nAJBDelayOff in SampCnt[%d]",AJBCon[PortNum].CLI_AJB_DEL_OFFSET_MS);
      break;
    case 3 :
      printk("\r\nAJBDelayEstTimerMS[%d]",AJBCon[PortNum].CLI_AJB_DELAY_EST_TIMER);
      break;
    case 4 :
      printk("\r\nAJBDelayDropTimerMS[%d]",AJBCon[PortNum].CLI_AJB_DELAY_DROP_TIMER);
      break;
    case 5 :
      printk("\r\nOnEachDelayTrackEntryAllowMaxPktDropCnt[%d]", \
	           AJBCon[PortNum].CLI_AJB_ALLOW_PKT_DROP_PER_SLOT);
      break;
    case 6 :
      printk("\r\nReset-on-MaxNullPlay inSec[%ld]", \
		 (AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME/1000));
      break;
    case 7 :
      printk("\r\n RdSeqNumReset-on-MaxLateDropsMS[%d]", \
		  AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME);
      break;
    case 8 :
      printk("\r\nAllowHistFailCntThr[%d]",\
			  AJBCon[PortNum].CLI_AJB_AllowNullPlayPassFailCntThr);
      break;
    case  9 :
      if( SubIndex < 9 )
        printk("\r\nAllowDropPercentTable[%d]",  \
	      AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[SubIndex] );
      else
 	printk("\r\nErrSubIndex:0-8");
      break;
    case 10 :
      printk("\r\nCurrent-AJBMode:[%d]", AJBCon[PortNum].CLI_AJB_Mode);
      break;
    case 11 :
      printk("\r\nHist-Stastics-ResetTimerMS[%d]", \
            AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER);
      break;
    case 12 :
      printk("\r\nDeleayEstSigmaFact[%d]", \
        AJBCon[PortNum].CLI_AJB_DELAY_EST_SIGMA_FACTOR);
      break;
    case 13 :
      printk("\r\nDeleayGapEstSigmaFact[%d]", \
        AJBCon[PortNum].CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR);
      break;
    case 14 :
      printk("\r\nDeleayGapEstSigmaFact[%d]", \
         AJBCon[PortNum].CLI_AJB_DELAY_TRACK_SIGMA_FACTOR);
      break;
    case 15 :
      printk("\r\nAJB_WRITE_CNTR[%x]",AJB_WRITE_CNTR[PortNum]);
      break;
    case 16 :
      printk("\r\nAJB_READ_CNTR[%x]",AJB_READ_CNTR[PortNum]);
      break;
    case 17 :
      if( SubIndex == 32766 )
      {
        //--> Give Info on all Debug Parameters.
         for( i = 0; i < AJB_DEBUG_LOGGER_LEN; i++ )
         {
           if( i%5 == 0 )
             printk("\r\n");
           printk("[%s]", AJBDebugStr[i]);
         }
      }
      else if( SubIndex == 32767  )
      {//--> Provide  All  Debug Parameters.
        for( i = 0; i < AJB_DEBUG_LOGGER_LEN; i++ )
        {
  	  if( i%10 == 0 )
	    printk("\r\n");
          printk("[%x]",AJBDebug[PortNum][i]);
        }
      }
      else if ( SubIndex < AJB_DEBUG_LOGGER_LEN )
        printk("\r\n[%s][%x]",AJBDebugStr[SubIndex],
                        AJBDebug[PortNum][SubIndex]);
      else
        printk("\r\nErrAJBDebugSubIndex[0:%d]",(AJB_DEBUG_LOGGER_LEN -1));
      break;
    case 18 :
#if AJB_ENABLE_STATISTICS
      //---> History Log.
      HistInd =  AJB_HISTORY_INDEX[PortNum];
      if( SubIndex == 0 )
      {
        printk("\r\nHistAJBWtCnt");
        TempPtr = AJB_TOT_PKT_CNT_WT[PortNum];

      }
      else if( SubIndex == 1 )
      {
        printk("\r\nHistAJBDupPktCnt");
        TempPtr = AJB_DUP_PKT_CNT_WT[PortNum];

      }
      else if( SubIndex == 2 )
      {  
        printk("\r\nHistOFPktCnt");
        TempPtr = AJB_OVF_PKT_CNT_WT[PortNum];

      }
      else if( SubIndex == 3 )
      {
        printk("\r\nHistListMaxCnt");
        TempPtr = AJB_LIST_MAX[PortNum];

      }
      else if( SubIndex == 4 )
      {
        printk("\r\nHistListMinCnt");
        TempPtr = AJB_LIST_MIN[PortNum];
     
      }
      else if( SubIndex == 5 )
      {	
        printk("\r\nHistListRunCnt");
        TempPtr = AJB_LIST_CUR[PortNum];

      }
      else if( SubIndex == 6 )
      {
        printk("\r\nHistListNullCnt");
        TempPtr = AJB_LIST_NUL[PortNum];

      }
      else if( SubIndex == 7 )
      { 
        printk("\r\nHistListAllowNullCnt");
        TempPtr = AJB_ALLOW_NULL[PortNum];

      }
      else if( SubIndex == 8 )
      {
        printk("\r\nHistDelEstMax");
        TempPtr = AJB_DELAY_EST_MAX[PortNum];

      }
      else if( SubIndex == 9 )
      {
        printk("\r\nHistDelEstMin");
        TempPtr = AJB_DELAY_EST_MIN[PortNum];

      }
      else if( SubIndex == 10 )
      {
        printk("\r\nHistDelEstCur");
        TempPtr = AJB_DELAY_EST_CUR[PortNum];

      }
      else if( SubIndex == 11 )
      {
        printk("\r\nHistLateArriDropCnt");
        TempPtr = AJB_LATE_ARRIVE_DROP_CNT[PortNum];
		  
      }
      else if( SubIndex == 12 )
      {
        printk("\r\nHistDelayTrackDropCnt");
        TempPtr = AJB_DELAY_TRACK_DROP_CNT[PortNum];

      }
      else if( SubIndex == 13 )
      {
        printk("\r\nHistDelayTrackDropFreqCnt");
        TempPtr = AJB_DELAY_TRACK_DROP_FREQ_CNT[PortNum];
          
      }
      else if( SubIndex == 14 )
      {	
        printk("\r\nHistLateArriDropFreqCnt");
        TempPtr = AJB_LATE_ARRIVA_DROP_FREQ_CNT[PortNum];

      }
      else if( SubIndex == 15 )
      {
        printk("\r\nHistNullPlayFreqCnt");
        TempPtr = AJB_NULLPKT_PLAY_OUT_FREQ_CNT[PortNum];
    
      }
      else if( SubIndex == 16 )
      {
        printk("\r\nHistRdErrFlags");
        TempPtr = AJB_READ_ERROR_FLAG_HIST[PortNum];

      }
      else if( SubIndex == 17 )
      {
        printk("\r\nHistWtErrFlags");
        TempPtr = AJB_WRIT_ERROR_FLAG_HIST[PortNum];

      }
      else if( SubIndex == 18 )
      {
        printk("\r\nHistAllowNullPlayFailCnt");
        TempPtr = AJB_AllowNullPlayPassFailCntHist[PortNum];
      }
		  
      for( i = 0; i < AJB_HISTORY_LEN; i++ )
      {
        if( i%9 == 0 )
          printk("\r\n");
        printk("[%d]",  TempPtr[HistInd]);
	HistInd++;
        HistInd = HistInd % AJB_HISTORY_LEN;
      }
#endif

      break;
    case 19 :
      printk("\r\nAJBInitFlag[%d]", SMMJitBuff[PortNum].JitInitFlag);
      break;
    case 20 :
      if( SubIndex == 0 )
      {
        printk("\r\nMarkoState[%x]",Markov4Data[PortNum].MARKOV4STATE );
      }
      else if( SubIndex == 1 )
      {
        printk("\r\nBurustD[%x]Len[%x]", \
	( Word16 )Markov4Data[PortNum].BurustLossDensity,\
	              ( Word16 )Markov4Data[PortNum].BurustLength);
	}
        else if( SubIndex == 2 )
	{
          printk("\r\nGap-D[%x]Len[%x]", \
            ( Word16 )Markov4Data[PortNum].GapLossDensity,\
            ( Word16 )Markov4Data[PortNum].GapLength);
	}
        else if( SubIndex == 3 )
	{
          printk("\r\nAvePkt-Loss[%x]Nw[%x]Dis[%x]", \
	 ( Word16 )Markov4Data[PortNum].AvePktLossRateAbs,\
	       ( Word16 )Markov4Data[PortNum].AveNwPktLossRate,\
	        ( Word16 )Markov4Data[PortNum].AveDisPktLossRate );
	}
        else if( SubIndex == 4 )
	{
          printk("\r\nEst-Ie[%x]RF[%x]MOS-LQ[%x]", \
	     ( Word16 )Markov4Data[PortNum].Est_Ie,\
	         ( Word16 )Markov4Data[PortNum].Rating_Factor,\
		       ( Word16 )Markov4Data[PortNum].MOS_LQ );
	}
        else if( SubIndex == 5 )
	{
	   printk("\r\nEst-Id[%x]Ext-RF[%x]MOS-CQ[%x]", \
	      ( Word16 )Markov4Data[PortNum].Est_Id,\
	        (Word16)Markov4Data[PortNum].Rating_FactorExt,\
		               ( Word16 )Markov4Data[PortNum].MOS_CQ );
	}
        else if( SubIndex == 6 )
        {
           printk("\r\nRxConfig[%x]",Markov4Data[PortNum].RxConfig );
	}
	break;
      default :
        printk("\r\nAJBConfigRdIndexErr[%d]",Index);
	break;
  }//--> End of Switch Statement.
}//--> End of Cli_AJBSetPara

void AJBSetCon(uWord16 PortNum , AJBCliParaSt_  *AJBConPtr )
{
  AJBCon[PortNum].CLI_AJB_Mode          =  AJBConPtr->CLI_AJB_Mode;
  AJBCon[PortNum].CLI_AJB_MIN_DELAY_MS  =  AJBConPtr->CLI_AJB_MIN_DELAY_MS;
  AJBCon[PortNum].CLI_AJB_MAX_DELAY_MS  =  AJBConPtr->CLI_AJB_MAX_DELAY_MS;
  AJBCon[PortNum].CLI_AJB_DEL_OFFSET_MS =  AJBConPtr->CLI_AJB_DEL_OFFSET_MS;

  AJBCon[PortNum].CLI_AJB_DELAY_EST_TIMER = AJBConPtr->CLI_AJB_DELAY_EST_TIMER;
  AJBCon[PortNum].CLI_AJB_DELAY_DROP_TIMER  = AJBConPtr->CLI_AJB_DELAY_DROP_TIMER;  
  AJBCon[PortNum].CLI_AJB_ALLOW_PKT_DROP_PER_SLOT 
							= AJBConPtr->CLI_AJB_ALLOW_PKT_DROP_PER_SLOT;
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[0]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[0];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[1]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[1];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[2]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[2];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[3]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[3];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[4]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[4];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[5]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[5];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[6]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[6];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[7]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[7];
  AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[8]
						=   AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[8];
     
  AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME
                =   AJBConPtr->CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME;
  AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME 
                 =  AJBConPtr->CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME; 
  AJBCon[PortNum].CLI_AJB_AllowNullPlayPassFailCntThr
                 =  AJBConPtr->CLI_AJB_AllowNullPlayPassFailCntThr;

  AJBCon[PortNum].CLI_AJB_DELAY_EST_SIGMA_FACTOR    =
                             AJBConPtr->CLI_AJB_DELAY_EST_SIGMA_FACTOR;
  AJBCon[PortNum].CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR = 
                          AJBConPtr->CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR;
  AJBCon[PortNum].CLI_AJB_DELAY_TRACK_SIGMA_FACTOR    =
                          AJBConPtr->CLI_AJB_DELAY_TRACK_SIGMA_FACTOR;
  AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER = 
                          AJBConPtr->CLI_AJB_STASTICS_RESET_TIMER;
}

void AJBGetCon(uWord16 PortNum , AJBCliParaSt_  *AJBConPtr )
{
  AJBConPtr->CLI_AJB_Mode          =  AJBCon[PortNum].CLI_AJB_Mode;

  AJBConPtr->CLI_AJB_MIN_DELAY_MS  =  AJBCon[PortNum].CLI_AJB_MIN_DELAY_MS;
  AJBConPtr->CLI_AJB_MAX_DELAY_MS  =  AJBCon[PortNum].CLI_AJB_MAX_DELAY_MS;
  AJBConPtr->CLI_AJB_DEL_OFFSET_MS =  AJBCon[PortNum].CLI_AJB_DEL_OFFSET_MS;

  AJBConPtr->CLI_AJB_DELAY_EST_TIMER   = AJBCon[PortNum].CLI_AJB_DELAY_EST_TIMER;
  AJBConPtr->CLI_AJB_DELAY_DROP_TIMER  = AJBCon[PortNum].CLI_AJB_DELAY_DROP_TIMER;
  AJBConPtr->CLI_AJB_ALLOW_PKT_DROP_PER_SLOT 
					= AJBCon[PortNum].CLI_AJB_ALLOW_PKT_DROP_PER_SLOT;

  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[0]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[0];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[1]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[1];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[2]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[2];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[3]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[3];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[4]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[4];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[5]
 				      =   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[5];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[6]
   			=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[6];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[7]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[7];
  AJBConPtr->CLI_AJB_ALLOW_NULLS_PER_SLOT[8]
					=   AJBCon[PortNum].CLI_AJB_ALLOW_NULLS_PER_SLOT[8];
     
  AJBConPtr->CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME
                =   AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME;
  AJBConPtr->CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME 
                 =  AJBCon[PortNum].CLI_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME;
  AJBConPtr->CLI_AJB_AllowNullPlayPassFailCntThr
                 =  AJBCon[PortNum].CLI_AJB_AllowNullPlayPassFailCntThr;

  AJBConPtr->CLI_AJB_DELAY_EST_SIGMA_FACTOR    =
                              AJBCon[PortNum].CLI_AJB_DELAY_EST_SIGMA_FACTOR;  
  AJBConPtr->CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR = 
                          AJBCon[PortNum].CLI_AJB_GAP_DELAY_EST_SIGMA_FACTOR;
  AJBConPtr->CLI_AJB_DELAY_TRACK_SIGMA_FACTOR    =
                            AJBCon[PortNum].CLI_AJB_DELAY_TRACK_SIGMA_FACTOR;
  AJBConPtr->CLI_AJB_STASTICS_RESET_TIMER = 
                            AJBCon[PortNum].CLI_AJB_STASTICS_RESET_TIMER;
}
 
#endif


