/*
cidrxDataSt.h
*/
//#include "../include/CidRxCon.h"
//#include "Typedef.h"
#if CID_RX_DET
typedef struct{	           
               /*
			       User CLI Configuration parameter.                   
				   1. Bellcore  --> Default.
				   2. ETSI
				   3. NTT
			   */
			   Word16  CidrxComplainVer; 

		       /*
			    Run Time Decoded Data layer parameter.
				-1. Not yet arrived this parameter.
                 1. Mdmf
				 2. Sdmf
			   */
               Word16  MsgTypeFlag;    
			   Word16  MsgLenFlag;
			   /*  Run Time Decoded Data layer parameter.
				-1. Not yet arrived this parameter.
				> 0. is valid length.
			   */
			   Word16  MsgLen;  
			   Word16 MsgLenRun;
   
               //---> TIME FIELD.
			   Word16 TimeFlag;
			   Word16 TimeRunLen;
               Word16 TimeLen;

			   CHAR Month[2];   //--> 1 to 12
			   CHAR Day[2];     //--> 01-31
			   CHAR Hour[2];    //--> 00-23
			   CHAR Minute[2];  //--> 00-59
			   
               /*    Name Flag 
			         -1. Not yet arrived.
					 0. under detection.
					 1. number detection done.-Num avaial
					 2. number detection done.-Num confidentail or not avaial
					   ---->  "P" or "O"
			   */

			   Word16  NameFlag;     
			   Word16  NameFlagN;     
			   /*
			       Name Len : 0 Default
				            > 0 
			   */
               Word16  NameLen;
			   Word16  NameRunLen;
			   CHAR Name[80];

			   /*    Number Flag 
			         -1. Not yet arrived.
					 0. under detection.
					 1. number detection done.-Num avaial
					 2. number detection done.-Num confidentail or not avaial
					   ---->  "P" or "O"
			   */
			   Word16  NumberFlag;     //--> Num avail/non avail/confidentail
			   Word16  NumberFlagN;    //--> Num /non avail/confidentail
			   /*
			       Number Len : 0 Default
				              > 0 
			   */
			   Word16  NumberLen;
			   Word16  NumberRunLen;
               CHAR Number[80];	


			   /*    Check Error Flag :
			         -1. Not yet cal
					 0. Calculated No Error
					 1. Calculated Error in CheckSum.
			   */
			   //UCHAR  CheckSumRx;
               		   // UCHAR  CheckSumExp;
				//char  CheckSumRx;
				//char  CheckSumExp;

                             Word16  CheckSumRx;
                             Word16  CheckSumExp;

			   Word16 CheckSumErrFlag; 
			   Word16 CheckSumRun;

			   Word16 Done;
			   Word16 PrevRdIndex;

           }cidrx_st_;
#endif
