
/*
File Name: packconceal.h

Description: Header file for the Packet Loss Concealment algorithm

Date: 13-07-2001

*/

//#include "G711PLCtypedef.h"

void G711PlcInit(uWord16 CurChanNum);
void G711PLC(uWord16,Word16);

void dofe(void);			/* synthesize speech for erasure */
void addtohistory(void);   /* add a good frame to history buffer */

void scalespeech(void);   /* Attenuate the input speech with 20% ramp */
void getfespeech(void);  /*   */
void savespeech(void);
Word16 findpitch(void);			/* Find Short term Pitch   */   
void overlapadd(void);
void overlapaddatend(void);
void zeros(void);
void copy(Word16 *f, Word16 *t, Word16 cnt);

void Put_G711PLcCurchanInst(uWord16 CurChanNum);
void Get_G711PLcCurchanInst(uWord16 CurChanNum);

Word16 GetImpairment(void);





