#include<voiceconf.h> 

#ifndef _Call_Progress_
#define _Call_Progress_

#define FRAME_LEN 80
#define MAX_CHAN  MAX_VOICE_CHANNELS

#define CPIDLE		0x0000
#define CPRINGING	0x0001
#define CPBUSY		0x0002
#define CPREMOTEANSWER	0x0004
#define CPDIALTONE	0x0008
#define CPDETECT2100	0x0010
#define CPDETECTANSam	0x0020

#define CPFRACTION	0x4000
#define ANSFRACTION	0x4000

#define BUSY_TOLERENCE	   44//50
#define MAXBUSYTIME	600

/*	Number of samples for 10 ms = 960;
	Since averages are taken over an interval of 32 samples,
	Time = samples/32
*/
//#define original 
#ifdef original

#define	Cp_40ms			12
#define	Cp_50ms			15
#define	Cp_100ms		30
#define	Cp_250ms		75
#define	Cp_500ms		150
#define	Cp_900ms		270
#define	Cp_1000ms		300
#define	Cp_1300ms		390
#define	Cp_1500ms		450
#define	Cp_2100ms		630
#define	Cp_3500ms		1050
#define	Cp_5secs 		1500

#else

#define Cp_40ms                 4 //5
#define Cp_50ms                 5//6
#define Cp_100ms                10//12
#define Cp_250ms                25//30
#define Cp_500ms                50//60
#define Cp_900ms                90//108
#define Cp_1000ms               100//120
#define Cp_1300ms               130//156
#define Cp_1260ms               126//
#define Cp_1500ms               150//180
#define Cp_2100ms               210//252
#define Cp_2140ms               214 
#define Cp_3500ms               350//420
#define Cp_5secs                500//600

#endif

#define	Cp_Busy_Tolerence	Cp_50ms
#define	Cp_Max_Busy_Time	180

#define ANSAMADVANCE	0x66
#define ANSADVANCE	0x3800
#endif
