/*======================================================================
 *
 * Copyright (C) 2000 Chiplogic Inc. All rights reserved
 *
 * The information and source code contained herein is the exclusive
 * property of Chiplogic and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 *======================================================================
 */

/*======================================================================
 * File Name	:	legerity78d11.h
 * Description	:	codec related definations
 * CVS ID	:	
 *======================================================================
 */

/*======================================================================
 * History
 *
 * Date		Author			Comment
 * 3/07/2004   Gowri Satish Adimulam       	Initial version
 *======================================================================
 */

#ifndef _IDT821068_H_
#define _IDT821068_H_

#ifdef __cplusplus
extern "C" {
#endif

/*     Include files
 */
#include "../include/dspipc.h"

  //14 zcoff
  
   char z_coeff[]={
                             0x80,
				 0xa4,
				 0x00,
				 0x36,
				 0xfc,
				 0x7b,
				 0xfe,
				 0xe7,
				 0x00,
				 0xbb,
				 0x01,
				 0x73,
				 0x00,
				 0x60
                           };

   
      

    //rcoeff 14
    
	//Alaw
	char r_coeff[]={
		                  0x85,
				    0xbb,
				    0x00,
				    0x0b,
				    0xff,
				    0xe8,
				    0x00,
				    0x7f,
				    0x00,
				    0xd5,
				    0xfe,
				    0xcc,
				    0x40,
				    0xbb
		               };
	
	

	 //xcoeff  14	
	
	 //Alaw
	  char x_coeff[]={
	  	                     0x00,
					0x00,
					0xfd,
					0xb8,
					0x02,
					0xf6,
					0x00,
					0x0c,
					0xfc,
					0xbf,
					0x00,
					0x4f,
					0x40,
					0x6b
	  	          };



	 

	   
	   //Alaw
	  char grc_coeff[]={
	  	                        0x4e,
					   0x01
					   };

	  
	  

	  char gxc_filter[]={
	  	                        0xfe,
					   0x83,
	  	                        };
 

       
	  //b_filter coeff1 14

	  char b_filter_coeff1[]=
                                     {
                                      0xff,
					   0xb6,
					   0xff,
					   0x95,
					   0xff,
					   0xd4,
					   0x01,
					   0x88,
					   0x13,
					   0xb3,
					   0x28,
					   0xdb,
					   0x11,
					   0xf3,
	  	                       };


	     

	
	 //Alaw
		
	  char b_filter_coeff2[]=
	  	                       {
	  	                         0xfd,
					    0xdf,
					    0x81,
					    0x48,
					    0xff,
					    0xbc,
					    0xff,
					    0xbc,
					    0xff,
					    0xbb,
					    0xff,
					    0xba,
					    0xff,
					    0xba

	  	                      };
	 

	     

	 char err_level_threshold[]={ 0x04};

	 char echo_path_gain[]={0x04};

	
	 char adaptive_bfilter_coeff[]=
                                  {
                                    0x02,
					 0x20,
					 0x1c,
					 0x00
	 	};
	
	  
        
		//Alaw
	 char loop_supv_params[]={
	 	                                       0x0d,
                                                     0x80,
                                                     0x00,
                                                     0x7f,
                                                     0x0f,
                                                     0x00,
                                                     0x7f,
                                                     0x7f,
                                                     0x07,
                                                     0x0b,
                                                     0x7f
	 	};
	 
            //Ulaw
char analog_gain = {0x02};
	     

						     
	  char signal_generatorA[]={
	  	                                     0x00,
                                                   0x00,
                                                   0x01,
                                                   0x01,
                                                   0x5b,
                                                   0x4c,
                                                   0x39,
                                                   0x9a,
                                                   0x00,
                                                   0x00
	  	};
                                                   
  

#ifdef __cplusplus
}
#endif

#endif 
