#include <oswrapper.h>

extern JitBuffType_  SMMJitBuff[MAX_VOICE_CHANNELS];
uWord16  AJB_ALLOW_NULL[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
extern uWord16   AJB_ALLOW_NULLS_PER_SLOT[AJB_MAX_NO_OF_DELAY_LEVELS];
extern uWord16   AJB_READ_THRESHOLD[MAX_VOICE_CHANNELS];;
extern uWord16   AJB_TOTAL_PKTS_PER_SLOT[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------
//---> To Null palyed Total and Allowed Nulls Max----------------------
uWord16   AJB_AllowNullPlayPassFailCnt[MAX_VOICE_CHANNELS];
uWord16   AJB_AllowNullPlayPassFailCntThr[MAX_VOICE_CHANNELS];
//---------------------------------------------------------------------
uWord16  AJB_RESET_ON_MAX_LATE_PKT_DROP_TIMER[MAX_VOICE_CHANNELS];

#if AJB_ENABLE_STATISTICS
extern Word16    AJB_ISR_SCHEDULER_DURATION[MAX_VOICE_CHANNELS];
uWord16  AJB_AllowNullPlayPassFailCntHist[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord32  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIMER[MAX_VOICE_CHANNELS];
uWord32  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME[MAX_VOICE_CHANNELS];
uWord16  AJB_STASTICS_RESET_TIMER[MAX_VOICE_CHANNELS];
uWord16  AJB_HISTORY_INDEX[MAX_VOICE_CHANNELS];
uWord16  AJB_TOT_PKT_CNT_WT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_DUP_PKT_CNT_WT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_OVF_PKT_CNT_WT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_LIST_MAX[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_LIST_MIN[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_LIST_NUL[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_LIST_CUR[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_DELAY_EST_MAX[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_DELAY_EST_MIN[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_DELAY_EST_CUR[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];

uWord16  AJB_LATE_ARRIVE_DROP_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_DELAY_TRACK_DROP_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];

uWord16  AJB_DELAY_TRACK_DROP_FREQ_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_LATE_ARRIVA_DROP_FREQ_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_NULLPKT_PLAY_OUT_FREQ_CNT[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];

uWord16  AJB_READ_ERROR_FLAG_HIST[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord16  AJB_WRIT_ERROR_FLAG_HIST[MAX_VOICE_CHANNELS][AJB_HISTORY_LEN];
uWord32  AJB_HIST_TOT_PKT_CNT_WT[MAX_VOICE_CHANNELS];




void JitStatics(uWord16 PortNum)
{

  Word16  Temp16,HistIndex,DelayEst;
  uWord16 TempCntr =0,PktTotal;
  Word16  FrameLenErrDrops,CodecTypeErrDrops,BuffOfDrops;
  Word16  NoFreeRTPMemDrops,NoFreeCellMemDrops;
  uWord32 uTemp32;


  /* JITTER BUFFER HEALTH MONITORING WRT LATE DROP PACKET CNTRS
     For Every 2.5 Seconds */
  if(( SMMJitBuff[PortNum].LateDropRunCnt  > 
      AJB_RESET_ON_MAX_LATE_PKT_DROP_TIMER[PortNum] )&&
                   (SMMJitBuff[PortNum].ResetRdSeqNumber == 0))
  {
    SMMJitBuff[PortNum].RdErrFlag = 
                    ( SMMJitBuff[PortNum].RdErrFlag | 0x0800);
    SMMJitBuff[PortNum].LateDropRunCnt   = 0;
    SMMJitBuff[PortNum].ResetRdSeqNumber = 1;
  }


  if(SMMJitBuff[PortNum].ListCellMax < 
                            SMMJitBuff[PortNum].ListCellCnt ) 
    SMMJitBuff[PortNum].ListCellMax = 
                           SMMJitBuff[PortNum].ListCellCnt;

  if(SMMJitBuff[PortNum].ListCellMin > SMMJitBuff[PortNum].ListCellCnt )
    SMMJitBuff[PortNum].ListCellMin = 
                           SMMJitBuff[PortNum].ListCellCnt;

  DelayEst = AJB_READ_THRESHOLD[PortNum] * 
                             SMMJitBuff[PortNum].DelRemStepMS;
  if(SMMJitBuff[PortNum].DelayEstMax < DelayEst  )
    SMMJitBuff[PortNum].DelayEstMax =  DelayEst;

  if(SMMJitBuff[PortNum].DelayEstMin > DelayEst  )
    SMMJitBuff[PortNum].DelayEstMin =  DelayEst;

#ifdef AJB_COUNTERS_SET_AND_RESET
  /**************************************************************
     AJB PKT COUNTERS UPDATE
  **************************************************************/
  SMMJitBuff[PortNum].StatisticsResetTimer    += 1;
  if(SMMJitBuff[PortNum].StatisticsResetTimer  >
                             AJB_STASTICS_RESET_TIMER[PortNum] )
  {
   
    /*    JITTER BUFFER HEALTH MONITORING WRT NON SID 
          NULLS PLAY OUT For Every 2.5 Seconds
    */
    if( AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME[PortNum]  > 
      AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIMER[PortNum] )
    {
      SMMJitBuff[PortNum].RdErrFlag = 
	              ( SMMJitBuff[PortNum].RdErrFlag | 0x1000);
      SMMJitBuff[PortNum].Reset  = 1;
      AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME[PortNum] = 0;
    }
    else
      AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME[PortNum]
                            += SMMJitBuff[PortNum].ListNullCnt;

    /*	  1.5 MINUTES HISTORY  BUILD       */
    HistIndex = AJB_HISTORY_INDEX[PortNum];

    /*  Write ContextReports  */
    Temp16 = AJB_TOT_PKT_CNT_WT[PortNum][HistIndex];
    AJB_HIST_TOT_PKT_CNT_WT[PortNum]     -=  Temp16;
    Temp16 = SMMJitBuff[PortNum].WtPktCnt - 
                                SMMJitBuff[PortNum].PreWtPktCnt;
    SMMJitBuff[PortNum].PreWtPktCnt = SMMJitBuff[PortNum].WtPktCnt;
    if( Temp16 <  0 )
      Temp16 = 0;
    AJB_TOT_PKT_CNT_WT[PortNum][HistIndex]  =  Temp16;
    AJB_HIST_TOT_PKT_CNT_WT[PortNum]        = Temp16;

    /* Duplicate Drops at Write Side. */
    Temp16 =  
      SMMJitBuff[PortNum].WtDupDropCnt - 
                              SMMJitBuff[PortNum].PreWtDupDropCnt;
    SMMJitBuff[PortNum].PreWtDupDropCnt = 
                              SMMJitBuff[PortNum].WtDupDropCnt;
    if( Temp16 <  0 )
      Temp16 = 0;
    AJB_DUP_PKT_CNT_WT[PortNum][HistIndex] = Temp16;

    /* Wt Context packet drops due to FrameLen Error. */
    FrameLenErrDrops = 
      SMMJitBuff[PortNum].PreWtFrameLenErr -
                              SMMJitBuff[PortNum].WtFrameLenErr;
    SMMJitBuff[PortNum].PreWtFrameLenErr = 
                              SMMJitBuff[PortNum].WtFrameLenErr;
    if( FrameLenErrDrops < 0 ) 
      FrameLenErrDrops = 0;

    /* Wt Contexet Packet Drops due to Codec Type Error. */
    CodecTypeErrDrops = 
      SMMJitBuff[PortNum].PreWtCodecErr - 
                                SMMJitBuff[PortNum].WtCodecErr;
    SMMJitBuff[PortNum].PreWtCodecErr = 
                               SMMJitBuff[PortNum].WtCodecErr;
    if( CodecTypeErrDrops < 0) 
      CodecTypeErrDrops = 0;

    /* Wt Context drops due to Buffer OcerFlows. */
    BuffOfDrops = 
        SMMJitBuff[PortNum].WtOFDropCnt  -
                            SMMJitBuff[PortNum].PreWtOFDropCnt;
    SMMJitBuff[PortNum].PreWtOFDropCnt = 
                            SMMJitBuff[PortNum].WtOFDropCnt;
    if( BuffOfDrops < 0)
      BuffOfDrops = 0;

    /* Wt Context drops due to No Free rtp cells */
    NoFreeRTPMemDrops = 
        SMMJitBuff[PortNum].WtNoRtpMemDropCnt - 
                      SMMJitBuff[PortNum].PreWtNoRtpMemDropCnt;
    SMMJitBuff[PortNum].PreWtNoRtpMemDropCnt 
                       = SMMJitBuff[PortNum].WtNoRtpMemDropCnt;
    if( NoFreeRTPMemDrops < 0)
      NoFreeRTPMemDrops = 0;
    /* Wt Context drops due to No Free payload cells  */
    NoFreeCellMemDrops = 
      SMMJitBuff[PortNum].WtNoCellMemDropCnt 
                   = SMMJitBuff[PortNum].PreWtNoCellMemDropCnt;
    SMMJitBuff[PortNum].PreWtNoCellMemDropCnt 
                      = SMMJitBuff[PortNum].WtNoCellMemDropCnt;
    if( NoFreeCellMemDrops < 0 )
      NoFreeCellMemDrops = 0;

    AJB_OVF_PKT_CNT_WT[PortNum][HistIndex]  =  FrameLenErrDrops 
       + CodecTypeErrDrops + BuffOfDrops  +
               SMMJitBuff[PortNum].PutDupDropCnt + 
           NoFreeRTPMemDrops + NoFreeCellMemDrops;

    /*-->Estimate the Allowed Null Playout Threshold. */
    AJB_AllowNullPlayPassFailCnt[PortNum]   
      -= AJB_AllowNullPlayPassFailCntHist[PortNum][HistIndex];
          
    Temp16  =  SMMJitBuff[PortNum].MaxDelay / 50;
    if( Temp16  >=  AJB_MAX_NO_OF_DELAY_LEVELS )
      Temp16   = (AJB_MAX_NO_OF_DELAY_LEVELS-1);

    TempCntr  = ( AJB_ALLOW_NULLS_PER_SLOT[Temp16] * 
                  AJB_TOTAL_PKTS_PER_SLOT[PortNum])/100;

    PktTotal = SMMJitBuff[PortNum].ListNullCnt +
          SMMJitBuff[PortNum].LateDropCnt +
               SMMJitBuff[PortNum].DelayTrackPktDropCnt;

    if( PktTotal  > TempCntr   )
      AJB_AllowNullPlayPassFailCntHist[PortNum][HistIndex] = 1;
    else 
      AJB_AllowNullPlayPassFailCntHist[PortNum][HistIndex] = 0;
                         
    AJB_AllowNullPlayPassFailCnt[PortNum]       
       += AJB_AllowNullPlayPassFailCntHist[PortNum][HistIndex];
	
    AJB_LIST_MAX[PortNum][HistIndex]  = 
                               SMMJitBuff[PortNum].ListCellMax;
    AJB_LIST_MIN[PortNum][HistIndex]  = 
                               SMMJitBuff[PortNum].ListCellMin;
    
    AJB_LIST_NUL[PortNum][HistIndex]  = 
                               SMMJitBuff[PortNum].ListNullCnt;
    SMMJitBuff[PortNum].RxNullPlayPktCnt = 
                               SMMJitBuff[PortNum].ListNullCnt;
    AJB_LIST_CUR[PortNum][HistIndex]  = 
                               SMMJitBuff[PortNum].ListCellCnt;
    AJB_DELAY_EST_MAX[PortNum][HistIndex]=
                               SMMJitBuff[PortNum].DelayEstMax;
    AJB_DELAY_EST_MIN[PortNum][HistIndex]=
                               SMMJitBuff[PortNum].DelayEstMin;
    AJB_DELAY_EST_CUR[PortNum][HistIndex]=DelayEst;
    AJB_LATE_ARRIVE_DROP_CNT[PortNum][HistIndex] = 
 		               SMMJitBuff[PortNum].LateDropCnt;
    SMMJitBuff[PortNum].RxLateDropPktCnt = 
                               SMMJitBuff[PortNum].LateDropCnt;
    SMMJitBuff[PortNum].RxDelayTDropPktCnt =
                               SMMJitBuff[PortNum].DelayTrackPktDropCnt;   
    AJB_DELAY_TRACK_DROP_CNT[PortNum][HistIndex] = 
                     SMMJitBuff[PortNum].DelayTrackPktDropCnt;
    AJB_DELAY_TRACK_DROP_FREQ_CNT[PortNum][HistIndex] =  
                     SMMJitBuff[PortNum].DelayTrackFreqCntr;
    AJB_LATE_ARRIVA_DROP_FREQ_CNT[PortNum][HistIndex] = 
                     SMMJitBuff[PortNum].LateDropFreqCntr;
    AJB_NULLPKT_PLAY_OUT_FREQ_CNT[PortNum][HistIndex] = 
                     SMMJitBuff[PortNum].NullPlayFreqCntr;
    AJB_READ_ERROR_FLAG_HIST[PortNum][HistIndex] =  
                     SMMJitBuff[PortNum].RdErrFlag;
    AJB_WRIT_ERROR_FLAG_HIST[PortNum][HistIndex] =  
                     SMMJitBuff[PortNum].WtErrFlag;
    HistIndex++;
    HistIndex = HistIndex % AJB_HISTORY_LEN;
    AJB_HISTORY_INDEX[PortNum] =  HistIndex;
    uTemp32 =  SMMJitBuff[PortNum].RxLateDropPktCnt + 
                     SMMJitBuff[PortNum].DelayTrackPktDropCnt;
    if( SMMJitBuff[PortNum].RxNullPlayPktCnt < uTemp32 )
      SMMJitBuff[PortNum].RxNwLostPktCnt = 0;
    else
      SMMJitBuff[PortNum].RxNwLostPktCnt = 
    SMMJitBuff[PortNum].RxNullPlayPktCnt - uTemp32;

    /*  RESET THE COUNTERS.   */
    SMMJitBuff[PortNum].LateDropCnt          = 0;
    SMMJitBuff[PortNum].DelayTrackPktDropCnt = 0;
    SMMJitBuff[PortNum].PutDupDropCnt        = 0; 
    SMMJitBuff[PortNum].ListNullCnt          = 0;
    SMMJitBuff[PortNum].ListCellMax          = 0;
    SMMJitBuff[PortNum].ListCellMin          = 65535;
    SMMJitBuff[PortNum].DelayEstMax          = 0;
    SMMJitBuff[PortNum].DelayEstMin          = 65535;


    SMMJitBuff[PortNum].DelayTrackFreqCntr    = 0;
    SMMJitBuff[PortNum].LateDropFreqCntr      = 0;
    SMMJitBuff[PortNum].NullPlayFreqCntr      = 0;

    /* reset the Rd Error Flag.   */
    SMMJitBuff[PortNum].RdErrFlag       =  0;
    /* reset the Wt Error Flag.   */
    SMMJitBuff[PortNum].WtErrFlag       =  0;

    SMMJitBuff[PortNum].StatisticsResetTimer      = 0;
  }
#endif
  		
  /*   Increment the Silence ZoneCntr  */
  if( SMMJitBuff[PortNum].SidInterval  > 0 )
    SMMJitBuff[PortNum].SidInterval += 1;


  /* PLAY OUT DELAY   */
  if( SMMJitBuff[PortNum].AJBRdCntr >=  
                        SMMJitBuff[PortNum].RxFrameCntr )  	
  {
    SMMJitBuff[PortNum].ExpReadSeqNum += 1;
    SMMJitBuff[PortNum].AJBRdCntr      = 0;

    Temp16 = SMMJitBuff[PortNum].ExpReadSeqNum - 
                      SMMJitBuff[PortNum].LastReadSeqNum;
    if( Temp16 <  0 )
      Temp16 =  0;
    Temp16 = Temp16  * SMMJitBuff[PortNum].RxFrameMS;
    SMMJitBuff[PortNum].PlayOutDelay = Temp16;
  }	
  SMMJitBuff[PortNum].AJBRdCntr += SMMJitBuff[PortNum].RdRepThr;
}


#if 0
char AJBDebugStr[AJB_DEBUG_LOGGER_LEN][20] =
{
{"WtErrFlag"},  {"RdErrFlag"},   {"ReadThr"},    {"GapOff"},
{"FreeRtpCnt"}, {"FreeCellCnt"}, {"ListRtpCnt"}, {"ListCellCnt"},
{"WtOFDropCnt"},{"WtDupDropCnt"},{"WtNoCMDropCnt"}, {"WtNoRMDropCnt"},
{"DelTraTot"},  {"PlayOutDelay"},{"CodecType"}, {"FrameLen" },
{"ExpRdSqNum"}, {"LastRdSqNum"}
};
#endif
void AJBDumpDebugInfo(uWord16 *pData)
{
  Word16 port;
  uWord16 temp[22];
  copy_from_user(&port,pData,sizeof(Word16));
  AJBDebugTrace(port,temp);
  copy_to_user(pData,temp,22 * sizeof(uWord16));
}
void AJBDebugTrace(uWord16 PortNum,uWord16 *pout)
{

   //---> Group -4 words.
   pout[0]   =  SMMJitBuff[PortNum].WtErrFlag;
   pout[1]   =  SMMJitBuff[PortNum].RdErrFlag;
   pout[2]   =  AJB_READ_THRESHOLD[PortNum];
   pout[3]   =  SMMJitBuff[PortNum].GapOffset;

   pout[4]   =  SMMJitBuff[PortNum].FreeRtpCnt;
   pout[5]   =  SMMJitBuff[PortNum].FreeCellCnt;
   pout[6]   =  SMMJitBuff[PortNum].ListRtpCnt;
   pout[7]   =  SMMJitBuff[PortNum].ListCellCnt;

   pout[8]   =  SMMJitBuff[PortNum].WtOFDropCnt;
   pout[9]   =  SMMJitBuff[PortNum].WtDupDropCnt;
   pout[10]  =  SMMJitBuff[PortNum].WtNoCellMemDropCnt;
   pout[11]  =  SMMJitBuff[PortNum].WtNoRtpMemDropCnt;

   pout[13]  =  SMMJitBuff[PortNum].PlayOutDelay;


   pout[14]  =  SMMJitBuff[PortNum].CodecType;
   pout[15]  =  SMMJitBuff[PortNum].FrameLen;
   pout[16]  =  SMMJitBuff[PortNum].ExpReadSeqNum;
   pout[17]  =  SMMJitBuff[PortNum].LastReadSeqNum;
   pout[18]  =  SMMJitBuff[PortNum].OFRtpMarkCnt;
   pout[19]  =  SMMJitBuff[PortNum].OFCellMarkCnt;
   pout[20]  =  SMMJitBuff[PortNum].LateDropCnt;
   pout[21]  =  SMMJitBuff[PortNum].TotalNULLPlayed;
}

//-------------------------History Buffer Init-------------------------
void InitAJBStat(Word16 PortNum)
{
  int i;
  //-------------------AJB STATSTICS RESET TIMETR CONTROLS---------------
  AJB_STASTICS_RESET_TIMER[PortNum] =
      ( (DEF_AJB_STASTICS_RESET_TIMER) / AJB_ISR_SCHEDULER_DURATION[PortNum]);
  //---------------------AJB NULL &DROPS HITS RESET TIMTERS--------------
  AJB_RESET_ON_MAX_LATE_PKT_DROP_TIMER[PortNum] =
   ( (DEF_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME) / SMMJitBuff[PortNum].RxFrameMS);
  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIMER[PortNum] =
    ( (DEF_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME) / SMMJitBuff[PortNum].DelRemStepMS);
  AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME[PortNum] = 0;

  AJB_STASTICS_RESET_TIMER[PortNum] = DEF_AJB_STASTICS_RESET_TIMER;
  AJB_HISTORY_INDEX[PortNum]       = 0;

  for( i = 0; i < AJB_HISTORY_LEN; i++ )
  {
    AJB_TOT_PKT_CNT_WT[PortNum][i]= 0;
    AJB_DUP_PKT_CNT_WT[PortNum][i]= 0;
    AJB_OVF_PKT_CNT_WT[PortNum][i]= 0;

    AJB_LIST_MAX[PortNum][i]      = 0;
    AJB_LIST_MIN[PortNum][i]      = 0;
    AJB_LIST_NUL[PortNum][i]      = 0;

    AJB_ALLOW_NULL[PortNum][i]    = 0;
    AJB_LIST_CUR[PortNum][i]      = 0;

    AJB_DELAY_EST_MAX[PortNum][i] = 0;
    AJB_DELAY_EST_MIN[PortNum][i] = 0;
    AJB_DELAY_EST_CUR[PortNum][i] = 0;

    AJB_LATE_ARRIVE_DROP_CNT[PortNum][i] = 0;
    AJB_DELAY_TRACK_DROP_CNT[PortNum][i] = 0;

    AJB_DELAY_TRACK_DROP_FREQ_CNT[PortNum][i] =  0;
    AJB_LATE_ARRIVA_DROP_FREQ_CNT[PortNum][i] =  0;
    AJB_NULLPKT_PLAY_OUT_FREQ_CNT[PortNum][i] =  0;

    AJB_READ_ERROR_FLAG_HIST[PortNum][i] = 0;
    AJB_WRIT_ERROR_FLAG_HIST[PortNum][i] = 0;
    AJB_AllowNullPlayPassFailCntHist[PortNum][i] = 0;
  }
  AJB_HIST_TOT_PKT_CNT_WT[PortNum]     = 0;
  AJB_AllowNullPlayPassFailCnt[PortNum]     = 0;
}
#endif

void AJBTrackNullPacketPlayOut(Word16 PortNum)
{
  Word16  Temp16;
  uWord16 TempCntr =0,PktTotal;

  Temp16  =  SMMJitBuff[PortNum].MaxDelay / 50;
  if( Temp16  >=  AJB_MAX_NO_OF_DELAY_LEVELS )
    Temp16   = (AJB_MAX_NO_OF_DELAY_LEVELS-1);

  TempCntr  = ( AJB_ALLOW_NULLS_PER_SLOT[Temp16] *
                AJB_TOTAL_PKTS_PER_SLOT[PortNum])/100;

  PktTotal = SMMJitBuff[PortNum].ListNullCnt +
        SMMJitBuff[PortNum].LateDropCnt +
             SMMJitBuff[PortNum].DelayTrackPktDropCnt;
  if( PktTotal  > TempCntr   ) 
    AJB_AllowNullPlayPassFailCnt[PortNum]++; 

  /* JITTER BUFFER HEALTH MONITORING WRT LATE DROP PACKET CNTRS
     For Every 2.5 Seconds */
  if(( SMMJitBuff[PortNum].LateDropRunCnt  >
      AJB_RESET_ON_MAX_LATE_PKT_DROP_TIMER[PortNum] )&&
                   (SMMJitBuff[PortNum].ResetRdSeqNumber == 0))
  {
    SMMJitBuff[PortNum].LateDropRunCnt   = 0;
    SMMJitBuff[PortNum].ResetRdSeqNumber = 1;
  }
}
