/*======================================================================
 *
 * Copyright : (c) 2004 SAGEM SA - Site Velizy - URD2                       
 *
 * The information and source code contained herein is the exclusive
 * property of SAGEM and may not be disclosed, examined, or
 * reproduced in whole or in part without explicit written authorization
 * of the company.
 *
 *======================================================================
 */

/*======================================================================
 * File Name	:	si3050.h
 * Description	:
 * CVS ID	:	
 *======================================================================
 */

/*======================================================================
 * History
 *
 * Date 		Author 		Comment
 * Mars 2004 		LCe       	Initial version
 *======================================================================
 */
#define OHS_R16_6 	12
#define OHS2_R31_3	11
#define RZ_R16_1	10
#define RT_R16_0	9
#define ILIM_R26_1	8
#define DCV_R26_7	7
#define DCV_R26_6	6
#define DCV_R26_5	5
#define DCV_R26_4	4
#define DCV_R30_3	3
#define DCV_R30_2	2
#define DCV_R30_1	1
#define DCV_R30_0	0

#define NBE_ECHANT 20
#define RETARD_MESURE 30
#define DELAY_MESURE1 50
#define DELAY_MESURE 400
#define MIN_VOLTAGE_DROP 10


void si3050PCMSlotChange(UCHAR ucFXSPort);
//----------------------------------------------------------------------
// liste des indications remontes par le SI3050
//----------------------------------------------------------------------
typedef enum
	{
	repos,
	debut_1_sonnerie,
	fin_1_sonnerie,
	debut_2_sonnerie,
	debut_sonnerie,
	fin_sonnerie,
	taxe,
	inv_polarite_occupee,
	inv_polarite,
	ligne_HS,
	ligne_occupee,
	} te_si3050_indication;


extern UCHAR fxoState;
extern int si3050_vmax , si3050_ech_valid, si3050_pola_pos;
